﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Cvicenie3
{
    class Program
    {
        static void Main(string[] args)
        {
            InvoiceManager manager = new InvoiceManager();

            while (true)
            {
                String input = Console.ReadLine();
                if (input.Equals("exit"))
                {
                    return;
                }
                if (input.StartsWith("new")) //new 1 Google 50000
                {
                    AddNew(manager, input);
                }

                if (input.StartsWith("info")) //info 1
                {
                    PrintInfo(manager, input);
                }
                if (input.StartsWith("pay")) //pay 1 10000
                {
                    Pay(manager, input);
                }

                if (input.Equals("notpaid")) //notpaid
                {
                    NotPaid(manager);
                }
            }
        }

        static void NotPaid(InvoiceManager manager)
        {
            decimal amount = manager.GetNotPaidAmount();
            Console.WriteLine("Amount of not paid invoices: " + amount + " Kc");
        }

        static void Pay(InvoiceManager manager, String input)
        {
            String[] parts = input.Split(' ');
            if (parts.Length == 3)
            {
                int id;
                decimal amount;
                if (Int32.TryParse(parts[1], out id) && Decimal.TryParse(parts[2], out amount))
                {
                    Invoice invoice = manager.GetInvoice(id);
                    invoice.Pay(amount);
                    Console.WriteLine("Invoice paid");
                }
                else
                {
                    Console.WriteLine("Wrong format of number");
                }
            }
            else {
                Console.WriteLine("Wrong format of line");
            }
        }

        static void AddNew(InvoiceManager manager, String input)
        {
            String[] parts = input.Split(' ');
            if (parts.Length == 4)
            {
                int id;
                decimal amount;
                if (Int32.TryParse(parts[1], out id)
                    && Decimal.TryParse(parts[3], out amount))
                {
                    Invoice invoice = new Invoice(id, parts[2], amount);
                    manager.AddInvoice(invoice);
                    Console.WriteLine("Added new invoice");
                }
                else
                {
                    Console.WriteLine("Wrong format of number");
                }
            }
            else
            {
                Console.WriteLine("Wrong format of line");
            }
        }

        static void PrintInfo(InvoiceManager manager, String input)
        {
            String[] parts = input.Split(' ');
            if (parts.Length == 2)
            {
                int id;
                if (Int32.TryParse(parts[1], out id))
                {
                    Invoice invoice = manager.GetInvoice(id);
                    Console.WriteLine(invoice);
                }
                else
                {
                    Console.WriteLine("Wrong format of number");
                }
            }
            else
            {
                Console.WriteLine("Wrong format of line");
            }
        }
    }
}
